
-- # import fin
-- # import nat
-- # import vec

mutual

  data Ctx : Nat -> Set where
    ε : Ctx 0
    (&) (n:Nat) : (ctx:Ctx n) -> Typ ctx -> Ctx (suc n)

  Typ (n:Nat) : Ctx n -> Set
  Typ ctx = Typ' _ ctx

  data Typ' : (n:Nat) -> Ctx n -> Set where
    pi (n:Nat)(ctx:Ctx n)  : (a : Typ ctx) -> Typ (ctx & a) -> Typ ctx
    set	(n:Nat)(ctx:Ctx n) : Typ ctx
    el (n:Nat)(ctx:Ctx n)  : (t:Term ctx set) -> Typ ctx

  Term (n:Nat) : (ctx : Ctx n) -> Typ ctx -> Set
  Term ctx t = Term' _ ctx t

  data Term' : (n:Nat) -> (ctx : Ctx n) -> Typ ctx -> Set where
    var (n:Nat)(ctx:Ctx n) : (i:Fin n) -> Term ctx set
    λ (n:Nat)(ctx:Ctx n)(a:Typ ctx)(b:Typ (ctx & a))(t:Term (ctx & a) b) :
      Term ctx (pi a b)

