-- Proving simple properties about addition using the agdaLight-FOL connection
-- Author :: Andreas Abel, Thierry Coquand
-- Created:: 2004-11-17
-- Source :: agdaLight/notes/ex1.agda

-- # import Property

-- backward compatibility
Eq : (A:Set) -> A -> A -> Prop
Eq A a b = a == b

-- Natural Numbers

N     : Set
Z     : N 
S     : N -> N 
indN  : (P : N -> Prop) -> 
         P Z -> 
         ((x:N) -> P x -> P (S x)) -> 
         (x:N) -> P x

-- Axioms about addition

infixl 6 +
(+)   : N -> N -> N
add_Z : (x:N) -> Eq N (x + Z) x
add_S : (x:N) -> (y:N) -> Eq N (x + S y) (S (x + y))

-- Property:: 0 + x == x

addZ_ : N -> Prop 
addZ_ = \ x -> Eq N (Z + x) x

-- Proof

thm : (x:N) -> addZ_ x
thm =
    let base : addZ_ Z
	base = fol-plugin (add_Z)

	step : (x:N) -> addZ_ x -> addZ_ (S x)
	step = \ x -> \ ih -> fol-plugin (add_S, ih)

    in indN addZ_ base step
